#include "Patcher.h"

DWORD Patcher::protect = 0;
DWORD Patcher::adress = 0;
DWORD Patcher::size = 0;

void Patcher::BeginWrite(DWORD a_s, DWORD a_e)
{
	adress = a_s;
	size = a_e - a_s;
	VirtualProtect((LPVOID)adress, (SIZE_T)size , PAGE_READWRITE, &protect);
}

void Patcher::EndWrite()
{
	VirtualProtect((LPVOID)adress, (SIZE_T)size , protect, NULL);
}

void Patcher::WriteByte(DWORD adress, int value)
{
	*(LPBYTE)adress = (BYTE)value;
}

void Patcher::WriteWord(DWORD adress, int value)
{
	*(LPWORD)adress = (WORD)value;
}

void Patcher::WriteDword(DWORD adress, int value)
{
	*(LPDWORD)adress = (DWORD)value;
}

void Patcher::WriteCall(DWORD adress, int value)
{
	WriteByte(adress, 0xE8); // write CALL opcode
	WriteDword(adress + 1, value - adress - 5);
}
void Patcher::WriteCall(DWORD adress, LPVOID value)
{
	WriteByte(adress, 0xE8); // write CALL opcode
	WriteDword(adress + 1, (DWORD)value - adress - 5);
}
void Patcher::WriteCall(DWORD adress, LPVOID value, int length)
{
	WriteByte(adress, 0xE8); // write CALL opcode
	WriteDword(adress + 1, (DWORD)value - adress - 5);
	WriteNop(adress + 6, length - 5);
}

void Patcher::WriteJmp(DWORD adress, int value)
{
	WriteByte(adress, 0xE9); //write JMP opcode
	WriteDword(adress + 1, value - adress - 5);
}
void Patcher::WriteJmp(DWORD adress, LPVOID value)
{
	WriteByte(adress, 0xE9); //write JMP opcode
	WriteDword(adress + 1, (DWORD)value - adress - 5);
}

void Patcher::WriteJmp(DWORD adress, LPVOID value, int length)
{
	WriteByte(adress, 0xE9); //write JMP opcode
	WriteDword(adress + 1, (DWORD)value - adress - 5);
	WriteNop(adress + 6, length - 5);
}

void Patcher::WriteNop(DWORD adress, int count)
{
	for (int i = 0; i < count; i++)
		WriteByte(adress + i, 0x90);
}
