#pragma once

#ifdef UNICODE
	#undef UNICODE
#endif

#define WIN32_LEAN_AND_MEAN	

#include <windows.h>
#include <string.h>
#include <stdio.h>

#include "Patcher.h"

typedef unsigned __int8		_byte_;
typedef unsigned __int16	_word_;
typedef unsigned __int32	_dword_;
typedef signed __int8		_int8_;
typedef _int8_				_char_;
typedef signed __int16		_int16_;
typedef signed __int32		_int32_;
typedef _dword_				_ptr_;
typedef _int32_				_bool_;

typedef _ptr_ (__cdecl *_func_homm3_MemAlloc_)(_dword_ size);
#define homm3_MemAlloc(size) ((_func_homm3_MemAlloc_)0x617492)((_dword_)(size))

typedef void (__cdecl *_func_homm3_MemFree_)(_ptr_ ptr);
#define homm3_MemFree(ptr) ((_func_homm3_MemFree_)0x60B0F0)((_ptr_)(ptr))

typedef _ptr_ (__thiscall *_func_homm3_DlgButton_Create_)(_ptr_ this_, _int32_ x, _int32_ y, _int32_ width, _int32_ height, _word_ id, _char_* def_name, _dword_ def_frame_index, _dword_ press_def_frame_index, _bool_ close_dialog, _dword_ hotkey, _dword_ flags);
#define homm3_DlgButton_Create(this_, x, y, width, height, id, def_name, def_frame_index, press_def_frame_index, close_dialog, hotkey, flags) \
	((_func_homm3_DlgButton_Create_)0x455bd0)((_ptr_)(this_), (_int32_)(x), (_int32_)(y), (_int32_)(width), (_int32_)(height), (_word_)(id), (_char_*)(def_name), (_dword_)(def_frame_index), (_dword_)(press_def_frame_index), (_bool_)(close_dialog), (_dword_)(hotkey), (_dword_)(flags))

typedef void (__thiscall * _func_homm3_DlgItemList_AddItem)(_ptr_ this_, _ptr_ a2, _dword_ a3, _ptr_* p_item);
#define DlgItemList_AddItem(list, ptr_item) ((_func_homm3_DlgItemList_AddItem)0x5FE2D0)((_ptr_)(list), *(_ptr_*)((_ptr_)(list) + 8), 1, (_ptr_*)(ptr_item))


class _ButtonSetup_
{
public:
	_ButtonSetup_(){}
	int parent;
	int ID;
	int x;
	int y;
	int width;
	int height;
	char* def_name;
	int def_frame;
	int def_frame_press;
	int colorize;
	int hotkey;
};