#ifdef UNICODE
	#undef UNICODE
#endif
#ifdef _UNICODE
	#undef _UNICODE
#endif

#define WIN32_LEAN_AND_MEAN

#include<windows.h>
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<shellapi.h>

#include"resource.h"

#define APP_TITLE "HoMM 3 KeyCode"


HWND htxt;
HWND hdlg;

HICON hIco;
HICON hIcoSmall;

LRESULT CALLBACK DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

	int wmId, wmEvent;

	switch (message) 
	{
	case WM_INITDIALOG:
		hdlg = hDlg;

		SendMessage( hDlg, WM_SETICON, ICON_BIG, (LPARAM)hIco);
		SendMessage( hDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcoSmall);
		htxt = GetDlgItem(hDlg,IDC_TXT);

		SetWindowPos(hDlg, HWND_TOP,(GetSystemMetrics(SM_CXSCREEN)-204)/2, (GetSystemMetrics(SM_CYSCREEN)-142)/2,0,0,SWP_NOZORDER | SWP_NOSIZE);
		break;

	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		switch (wmId)
		{
		case IDC_BTN:
			DestroyWindow(hDlg);
			return TRUE;
		}
		break;

	case WM_USER:
		{
			char text[260];
			int keycode = (lParam >> 16) & 0xFF;
			sprintf(text,"%d", keycode);
			SendMessage(htxt, WM_SETTEXT, 0, (LPARAM)text);
		}
	case WM_KEYUP:
	case WM_SYSKEYUP:
		return FALSE;

	case WM_CLOSE:
		DestroyWindow(hDlg);
		return TRUE;
	case WM_DESTROY:
		PostQuitMessage(0);

	}
	return FALSE;
}

int APIENTRY WinMain(HINSTANCE hInstance,
			HINSTANCE hPrevInstance,
			LPTSTR    lpCmdLine,
			int       nCmdShow)
{

	hIco = LoadIcon(hInstance, (LPCTSTR)IDI_MAIN);
	hIcoSmall = LoadIcon(hInstance, (LPCTSTR)IDI_SMALL);

	HWND hdlg = CreateDialog(hInstance, (LPTSTR)IDD_MAIN, NULL, (DLGPROC)DlgProc);

    ShowWindow(hdlg, nCmdShow);
	UpdateWindow(hdlg);

	MSG msg;

	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		if ((msg.message == WM_KEYDOWN) || (msg.message == WM_SYSKEYDOWN))
		{
			if (msg.hwnd != hdlg)
				msg.hwnd = hdlg;

			msg.message = WM_USER;
		}
		DispatchMessage(&msg);
	}

	return (int) msg.wParam;
}
